#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/times.h>
#include <string.h>
#include <unistd.h>
#include <dirent.h>
#include <limits.h>
#include <ctype.h>


#define EOLN '\n'
#define EOS '\0'
#define NAMELEN 50
#define MAXERR 10000
#define MAXVSYMBOL 200
#define NUMQUANT 4
#define NUMINP 3
#define NUMOP 4
#define NUMMATH 6
#define NUMLOG 6
#define NUMCON 10 
#define NUMFIRST 6
#define LPAREN '('
#define RPAREN ')'
#define WHERE ';'
#define COMMA ','
#define NUMTABLE 26
#define MAXPRIORITY 6
#define NUMBIN 7
#define NUMUNARY 2

struct Vtemp
{
	char	vname[NAMELEN];
	struct Pnode	*vtype;
	char 	value[NAMELEN];
	int		vset;
	struct Vtemp *next;
};


struct Snode
{
	char	symbol[NAMELEN];
	struct	Snode *next;
	struct	Snode *list;
};

	
struct Qnode
{
	char 	qname[NAMELEN];
	struct  Pnode *qdata;
	struct	Vtemp **qvl;
	struct	Qnode *next;
};


struct MetaList
{
	struct Snode *predicates;
	struct Qnode *quantifiers;
	struct Snode *conditions;
	struct MetaList *next;
};

struct MetaAtom
{
	int min;
	int max;
	struct MetaAtom *next;
	struct MetaList *metalist;
};


struct VNode
{
	char vsymbol[MAXVSYMBOL];
	int	 vid;
	int		value;
	int		horn;
	struct VNode *left;
	struct VNode *right;
};

struct CardAtom
{
	struct VNode **list;
	int ccnt;
	int max;
	int min;
};

struct Clause 
{
	struct VNode **bdy;
	struct VNode **hd;
	struct CardAtom **mbdy;
	struct CardAtom **mhd;
	int		horn;
	int		metabdycnt;
	int		metahdcnt;
	int		bdycnt;
	int		hdcnt;
};


struct Cnode
{
	char			cname[NAMELEN];
	char			value[NAMELEN];
	struct Cnode	*next;
};




struct Pnode
{
	char			name[NAMELEN];
	char			ptype[NAMELEN];
	int				arity;
	int				horn;
	int				count;
	struct Snode	*parameters;
	struct Pnode	*next;
};

struct Rnode
{
	struct MetaAtom *mhd;
	struct MetaAtom *mbdy;
	struct Snode	*head;
	struct Snode	*body;
	struct Snode	*conditions;
	struct Qnode	*quantifiers;
	struct Snode	*logcond;
	int				rid;
	int				horn;
	int				bdycnt;
	int				hdcnt;
	struct Rnode	*next;
};


struct Snode 	*Stack[MAXVSYMBOL];
int 			EvalStack[MAXVSYMBOL];
struct Pnode 	*Plist;
struct Pnode 	*Dlist;
struct Vtemp 	*Vlist;
struct Cnode	*Clist;
struct VNode  	*VTree;
struct Rnode 	*Rlist;
struct Clause 	*Cls;
int Stkptr;



static char *OPTABLE[]= {"->",",","|",":-","+","-","*","/","abs","mod","max","min","==","<",">","<=",">=","!=","=","[","_","]","{","}",";",":"};
static int PRIORITY[]= {0,0,0,0,4,4,5,5,6,6,6,6,2,2,2,2,2,2,2,0,0,0,0,0,0,0};
static char *UNARY[]= {"!","abs"};
static char *BINARY[]= {"+","-","*","/","mod","max","min"};


static char *MATHOP[]={"+","-","*","/","abs","mod","max","min","!"};
static char *LOGICOP[]={"==","<",">","<=",">=","!="};
static char *FIRSTPOS[]={"-","=","<",">","!",":"};
int EFLAG[MAXERR+1];
int ELINE[MAXERR+1];
int EPOS[MAXERR+1];
int EDESC[MAXERR+1];
int symptr;                                                        
char ErrorMessages[MAXERR+1][MAXERR+1];
int NumErrMess;
int EXstate;
