#include "structalloc.h"

extern int num_pred;
extern int num_data;
extern int num_var;
extern int num_err;
extern int num_rules;
extern int Nsymbol;
extern int Nconst;
extern int num_cons;


FILE *errorfile;

struct Qnode *NewQNode(char *name,struct Pnode *qd)
{

	struct Qnode *tmp;

	if((tmp=(struct Qnode *)malloc(sizeof(struct Qnode)))==NULL){
		fprintf(errorfile,"Error: cannot allocat struct Qnode\n");
		exit(1);
	}

	strcpy(tmp->qname,name);
	tmp->qdata=qd;
	if(qd){
		if(!(tmp->qvl=(struct Vtemp **)malloc(sizeof(struct Vtemp *)*qd->arity))){
			fprintf(stderr,"Error: cannont allocate struct qvl");
			exit(1);
		}
	}
	else 
		tmp->qvl=NULL;
	tmp->next=NULL;

	return(tmp);
}



void EvalPush(int value)
{
	if(Stkptr<MAXVSYMBOL)
		EvalStack[Stkptr++]=value;
}

int EvalPop(void)
{
	if(Stkptr>0)
		return(EvalStack[--Stkptr]);
	return(0);
}
		

void Push(struct Snode *sym)
{

	sym->next=NULL;
	if(Stkptr<MAXVSYMBOL)
		Stack[Stkptr++]=sym;		

}

struct Snode *Pop(void)
{
	
	if(Stkptr>0)
		return(Stack[--Stkptr]);
	return(NULL);
}

struct Snode *NewSymbol(char *name)
{

	struct Snode *tmp;

	if((tmp=(struct Snode *)malloc(sizeof(struct Snode)))==NULL){
		fprintf(errorfile,"Error: cannot allocat struct Snode\n");
		exit(1);
	}

	strcpy(tmp->symbol,name);
	tmp->next=NULL;
	tmp->list=NULL;

	return(tmp);
}

void NewConst(char *name,char *val)
{

	struct Cnode *tmp;

	if((tmp=(struct Cnode *)malloc(sizeof(struct Cnode)))==NULL){
		fprintf(errorfile,"Error: cannot allocat struct Cnode\n");
		exit(1);
	}

	strcpy(tmp->cname,name);
	strcpy(tmp->value,val);
	tmp->next=NULL;
	if(Clist)
		tmp->next=Clist;
	Clist=tmp;


	return;
}

struct Vtemp *NewVarTemp(struct Pnode *dtype,char *name)
{

	struct Vtemp *tmp;

	if((tmp=(struct Vtemp *)malloc(sizeof(struct Vtemp)))==NULL){
		fprintf(errorfile,"Error: cannot allocat struct Vtemp\n");
		exit(1);
	}

	tmp->vtype=dtype;
	strcpy(tmp->vname,name);
	strcpy(tmp->value,"");
	tmp->vset=0;
	/*
	tmp->next=NULL;
	if(Vlist==NULL)
		Vlist=tmp;
	else {
		vptr=Vlist;
		while(vptr->next)
			vptr=vptr->next;
		vptr->next=tmp;
	}
	*/
	tmp->next=Vlist;
	Vlist=tmp;
	
	return(tmp);
}

struct Pnode *NewData(char *name)
{
	struct Pnode *tmp;
	 
	if((tmp=(struct Pnode *)malloc(sizeof(struct Pnode)))==NULL){
		fprintf(errorfile,"Error: cannot allocat struct Pnode\n");
		exit(1);
	}

	strcpy(tmp->name,name);
	tmp->arity=0;
	tmp->count=0;
	if(Dlist==NULL){
		tmp->next=NULL;
	}
	else{
		tmp->next=Dlist;
	}
	Dlist=tmp;
	tmp->parameters=NULL;
	return(tmp);
}

struct Pnode *NewPredicate(char *name,struct Snode *list,int number)
{
	struct Pnode *tmp;
	 
	if((tmp=(struct Pnode *)malloc(sizeof(struct Pnode)))==NULL){
		fprintf(errorfile,"Error: cannot allocat struct Pnode\n");
		exit(1);
	}

	strcpy(tmp->name,name);
	strcpy(tmp->ptype,"");
	tmp->arity=number;
	tmp->horn=0;
	tmp->count=0;
	tmp->next=NULL;
	tmp->parameters=list;
	return(tmp);
}

void AddPredicate(struct Pnode *pptr)
{
	 
	if(Plist!=NULL)
		pptr->next=Plist;
	Plist=pptr;
}

struct CardAtom *NewCardAtom(void)
{
	struct CardAtom *tmp;

	if((tmp=(struct CardAtom *)malloc(sizeof(struct CardAtom)))==NULL){
		fprintf(errorfile,"Error: cannot allocate struct CardAtom\n");
		exit(1);
	}
	memset(tmp,0,sizeof(struct CardAtom));
	return(tmp);
}

struct Clause *NewClause(void)
{
	struct Clause *tmp;

	if((tmp=(struct Clause *)malloc(sizeof(struct Clause)))==NULL){
		fprintf(errorfile,"Error: cannot allocate struct Clause\n");
		exit(1);
	}
	memset(tmp,0,sizeof(struct Clause));
	return(tmp);
}

struct VNode *NewVNode(char *name,int horn)
{
	struct VNode *tmp;

	if((tmp=(struct VNode *)malloc(sizeof(struct VNode)))==NULL){
		fprintf(errorfile,"Error: cannot allocate struct VNode\n");
		exit(1);
	}
	strcpy(tmp->vsymbol,name);
	tmp->vid=0;
	tmp->horn=horn;
	tmp->value=-1;
	tmp->left=tmp->right=NULL;
	return(tmp);
}

struct MetaList *NewMetaList(void)
{
	struct MetaList *tmp;

	if((tmp=(struct MetaList *)malloc(sizeof(struct MetaList)))==NULL){
		fprintf(errorfile,"Error: cannot allocate struct MetaList\n");
		exit(1);
	}
	memset(tmp,0,sizeof(struct MetaList));
	tmp->conditions=NewSymbol("head");
	tmp->quantifiers=NewQNode("head",NULL);
	return(tmp);
}

struct MetaAtom *NewMetaAtom(void)
{
	struct MetaAtom *tmp;

	if((tmp=(struct MetaAtom *)malloc(sizeof(struct MetaAtom)))==NULL){
		fprintf(errorfile,"Error: cannot allocate struct MetaAtom\n");
		exit(1);
	}
	tmp->max=-1;
	tmp->min=0;
	tmp->next=NULL;
	tmp->metalist=NULL;
	return(tmp);
}

struct Rnode *NewRule(void)
{
	struct Rnode *tmp;
	static int count=0;

	if((tmp=(struct Rnode *)malloc(sizeof(struct Rnode)))==NULL){
		fprintf(errorfile,"Error: cannot allocate struct Rnode\n");
		exit(1);
	}
	
	memset(tmp,0,sizeof(struct Rnode));
	tmp->conditions=NewSymbol("head");
	tmp->quantifiers=NewQNode("head",NULL);
	tmp->rid=++count;

	return(tmp);
}

void AddRuleToList(struct Rnode *rule)
{
	struct Rnode *rtmp;
	int done=0;

	if(Rlist){
		if(!rule->mhd&&!rule->mbdy&&((!rule->hdcnt&&rule->bdycnt==1)
		||(!rule->bdycnt&&rule->hdcnt==1))){
			rule->next=Rlist;
			Rlist=rule;
		}
		else{
			rtmp=Rlist;
			while(rtmp->next&&!done){
				if(((rule->mhd||rule->mbdy)&&(!rtmp->mhd&&!rtmp->mbdy))
				||((rule->hdcnt+rule->bdycnt)>(rtmp->hdcnt+rtmp->bdycnt)))
					rtmp=rtmp->next;
				else done=1;
			}
			rule->next=rtmp->next;
			rtmp->next=rule;
		}
	}
	else{
		Rlist=rule;
	}
}


void PrintVar(FILE *optr,struct VNode *root)
{

	if(!root)
		return;
	if(root->value)
		fprintf(optr,"c %i %s \n",root->vid,root->vsymbol);
	if(root->left!=NULL)
		PrintVar(optr,root->left);
	if(root->right!=NULL)
		PrintVar(optr,root->right);
	return;
}


